+++

title = "Digitální hodiny s ATmega8"
perex_e = "Toto zapojení využívá k řízení hodin mikroprocesor od firmy Atmel - ATmega8. Originální realizace na Daqq.eu. Celé zapojení je poměrně jednoduché, ale je třeba naprogramovat mikroprocesor. Způsobů jak toho úspěšně dosáhnout je mnoho.  Pokud nechce stavět něco složitého, jeden jednoduchý programátor je zde. My jsme si pak na kroužku postavili tento do USB. Všechny součástky jsou vývodové a pod mikroprocesor jsme zatím dali raději patici pro snažší manipulaci s mikroprocesorem. 
..
.

"
tags = ["Článek"]
+++

Toto zapojení využívá k řízení hodin mikroprocesor od firmy Atmel - ATmega8. Originální realizace na Daqq.eu. Celé zapojení je poměrně jednoduché, ale je třeba naprogramovat mikroprocesor. Způsobů jak toho úspěšně dosáhnout je mnoho.  Pokud nechce stavět něco složitého, jeden jednoduchý programátor je zde. My jsme si pak na kroužku postavili tento do USB. Všechny součástky jsou vývodové a pod mikroprocesor jsme zatím dali raději patici pro snažší manipulaci s mikroprocesorem. 
..
.


Toto zapojení jsme pojali jako motivační, postavit si něco praktického s využitím mikroprocesoru. Celé hodiny jsou tvořeny dvěma [DPS](http://cs.wikipedia.org/wiki/Plo%C5%A1n%C3%BD_spoj), které jsou na sebe navzájem kolmé. V místě kontaktu desek jsou sletovány pájecí plošky a tím je zaručen přenost signálu pro displej. Ihned po zapojení na napájení by se na hodinách měl objevit čas 00:00 a již hodiny běží (pokud máte samozřejmě správně zapojení a naprogramován mikroprocesor). Aktuální čas nastavíte pomocí tlačítek SW1 (minuty) a SW2 (hodiny). Celé hodiny je pak možné zabudovat do krabičky a lze je napájet 9V baterií nebo lépe adaptérem ze sítě (spotřeba 100mA). Displej jsme použili [CA56-21SRWA](http://www.tme.eu/cz/katalog/artykuly.phtml?search=CA56-21SWRA&idp=1#cleanParameters%3D1%26search%3DCA56-21SRWA%26bf_szukaj%3D+) ([2](http://www.hledejsoucastky.cz/Hledani.aspx?lastsearch=CA56-21SRWA)), na které máme i nakreslený plošný spoj. Mikroprocesor je [ATmega8 - 16PU](http://www.hledejsoucastky.cz/Hledani.aspx?lastsearch=ATMEGA8-16PU) v pouzdru DIL28.![](/upload/ok1wmr/clanky/hodiny/02.jpg)
Schéma:
![schema](/upload/ok1wmr/clanky/hodiny/sch.png).
Plošný spoj:
![pcb](/upload/ok1wmr/clanky/hodiny/pcb.png)![](/upload/ok1wmr/clanky/hodiny/03.jpg)![Plošky připravené k pájení - spojení dvou DPS](/upload/ok1wmr/clanky/hodiny/01.jpg).
PDF verze: [schéma](../upload/ok1wmr/clanky/hodiny/hodiny_sch.pdf), [plošný spoj 1:1](../upload/ok1wmr/clanky/hodiny/hodiny_dps.pdf), [osazovací plán](../upload/ok1wmr/clanky/hodiny/hodiny_osaz.pdf)Eagle 5.7: [SCH](../upload/ok1wmr/clanky/hodiny/hodiny_1.0.sch) a [BRD](../upload/ok1wmr/clanky/hodiny/hodiny_1.0.brd)Program: [hodiny.c](../upload/ok1wmr/clanky/hodiny/hodiny.c), [hodiny.hex](../upload/ok1wmr/clanky/hodiny/hodiny.hex) (.hex se nahrává do mikroprocesoru, můžete prohlížet v editoru txt) původní zdroj [Daqq.eu](http://daqq.eu/)Deska byla vyrobena [metodou nažehlením tonneru.](index.php/technicke-lanky/425-vyroba-plonych-spoj)[
](index.php/technicke-lanky/425-vyroba-plonych-spoj)Seznam součástek:R1-R8 - 330RR9-R11 - 10KC1,C2 - 22pC3 - 100nFC4, C5 - 100uF/16VIC1 - 7805 (TO220)IC4 - ATmega8-16PU (DIL28) + patice pro DIL28D1 - LED displej [CA56-21SRWA](http://www.tme.eu/cz/katalog/#cleanParameters%3D1%26searchClick%3D1%26search%3DCA56-21SRWA%26bf_szukaj%3D+)Q1 - krystal 14.7456 MHz - HC49
SW1, SW2 - mikrotlačítka s delším hmatníkem<object height="344" width="425" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"><param value="true" name="allowFullScreen"> <param value="always" name="allowscriptaccess"> <param value="http://www.youtube.com/v/CAZYkOt0Mgk&amp;hl=cs_CZ&amp;fs=1&amp;rel=0&amp;color1=0x2b405b&amp;color2=0x6b8ab6" name="src"><embed height="344" width="425" src="http://www.youtube.com/v/CAZYkOt0Mgk&amp;hl=cs_CZ&amp;fs=1&amp;rel=0&amp;color1=0x2b405b&amp;color2=0x6b8ab6" allowscriptaccess="always" allowfullscreen="true" type="application/x-shockwave-flash"></object> 

* * *

**Program v jazyce C**<title>Untitled</title> <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"> <meta name="generator" content="SynEdit HTML exporter"> <style type="text/css">&amp;amp;lt;!-- body { color: #000000; background-color: #FFFFFF; } .cpp1-assembler { } .cpp1-brackets { } .cpp1-comment { color: #008000; font-style: italic; } .cpp1-float { color: #000080; } .cpp1-hexadecimal { color: #000080; } .cpp1-character { } .cpp1-identifier { } .cpp1-illegalchar { } .cpp1-number { color: #000080; } .cpp1-octal { color: #0000FF; } .cpp1-preprocessor { } .cpp1-reservedword { font-weight: bold; } .cpp1-space { color: #008080; } .cpp1-string { color: #800000; } .cpp1-symbol { } --&amp;amp;gt;</style> 

```
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <stdio.h>

#define _s_A  2
#define _s_B  0
#define _s_C  6
#define _s_D  4
#define _s_E  3
#define _s_F  1
#define _s_G  7
#define _s_dot 5

const unsigned char segs[] =
{
    _BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F),    //0
    _BV(_s_B) | _BV(_s_C),    //1
    _BV(_s_A) | _BV(_s_B) | _BV(_s_D) | _BV(_s_E) | _BV(_s_G),    //2
    _BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_G),  //3
    _BV(_s_B) | _BV(_s_C) | _BV(_s_F) | _BV(_s_G),    //4
    _BV(_s_A) | _BV(_s_C) | _BV(_s_D) | _BV(_s_F) | _BV(_s_G), //5
    _BV(_s_A) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G), //6
    _BV(_s_A) | _BV(_s_B) | _BV(_s_C), //7
    _BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G),//8
    _BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_F) | _BV(_s_G),//9

    _BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G),    //A
    _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G),    //B
    _BV(_s_A) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F), //C
    _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_G), //D
    _BV(_s_A) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G), //E
    _BV(_s_A) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G) //F

};

#define _ms(n) (17*n)

void wait(unsigned int a)    //basic wait
{                           
    volatile unsigned int b,c;
    for(b=0;b!= a; b++)for(c=0;c!= 50;c++);
    return;
}

unsigned char prescale=0;
unsigned char sec=0;
unsigned char min_1=0;
unsigned char min_10=0;
unsigned char hour_1=0;
unsigned char hour_10=0;
unsigned char show_t=0;

   ISR(TIMER1_OVF_vect)
{
    if(++prescale == 225){prescale = 0;sec++;};
    if(sec>59){min_1++;sec=0;};
    if(min_1>9){min_1=0;min_10++;};
    if(min_10>5){min_10=0;hour_1++;};
    if(hour_1>9){hour_1=0;hour_10++;};
    if(hour_10>1 && hour_1>3){hour_1=0;hour_10=0;};

    if(++show_t==4) show_t=0;
    switch(show_t)
    {
        case 0:    //show minutes
            PORTC = 0x04;
            PORTD = (~segs[min_1]);
            break;
        case 1:    //show 10 minutes
            PORTC = 0x08;
            PORTD = (~segs[min_10]);
            break;
        case 2:    //show hours
            PORTC = 0x10;
            PORTD = (~segs[hour_1]) & ~_BV(_s_dot);
            break;
        case 3:    //show 10hours
            PORTC = 0x20;
            PORTD = (~segs[hour_10]);
            break;
        default:
            show_t = 0;
            break;
    }   
    return;
}

#define B1() (bit_is_clear(PINB,3))
#define B2() (bit_is_clear(PINB,4))
#define B_WAIT 300

#define nop() asm volatile ("nop;")

int main(void)
{

    TIMSK = 0x04;
    TCCR1B = 0x01;

    DDRD = 0xFF;
    DDRC = 0x3F;
    DDRB = 0x00;
    PORTB = 0xFF;

    sei();
    while(1)
    {
        if(B1())
        {
            wait(_ms(B_WAIT));
            min_1++;
            sec=0;
        }
        if(B2())
        {
            wait(_ms(B_WAIT));
            hour_1++;
            sec=0;
        }
    }
}

```

* * *

.....[http://krouzek.radioklub.cz](http://krouzek.radioklub.cz)
........

* * *

New layer...New layer...New layer...